(**************************************************************************)
(*                                                                        *)
(*  FORK                                                                  *)
(*                                                                        *)
(*  Author:  Franois Pottier, INRIA Paris-Rocquencourt                   *)
(*  Version: 20101109                                                     *)
(*                                                                        *)
(*  The copyright to this code is held by Institut National de Recherche  *)
(*  en Informatique et en Automatique (INRIA). All rights reserved. This  *)
(*  file is distributed under the license CeCILL-C (see file LICENSE).    *)
(*                                                                        *)
(**************************************************************************)

(* The standard definition of the [Y] fixed point combinator. *)

(* Because we do not have polymorphism at the kind level, [Y] must
   be assigned a monomorphic kind. We arbitrarily choose [T = *],
   but any other definition would work just as well. *)

kind T = *

default kind f : later T -> T

kind X = later (X -> T)

default kind x : X

type Y : (later T -> T) -> T =
  \f. (\x.f (x x)) (\x.f (x x))

lemma identity:
  forall f.
  Y f = Y f

lemma Yfix:
  forall f.
  Y f = f (Y f)

(* Using FORK's built-in support for recursive type definitions,
   we can also define a fixed point combinator as follows. *)

type Z : (later T -> T) -> T =
  \f. f (Z f)

lemma ZY:
  forall f.
  Y f = Z f
