(**************************************************************************)
(*                                                                        *)
(*  FORK                                                                  *)
(*                                                                        *)
(*  Author:  Franois Pottier, INRIA Paris-Rocquencourt                   *)
(*  Version: 20101109                                                     *)
(*                                                                        *)
(*  The copyright to this code is held by Institut National de Recherche  *)
(*  en Informatique et en Automatique (INRIA). All rights reserved. This  *)
(*  file is distributed under the license CeCILL-C (see file LICENSE).    *)
(*                                                                        *)
(**************************************************************************)

let return x =
  Some x

let (>>=) (o : 'a option) (k : 'a -> 'b option) : 'b option =
  match o with
  | None ->
      None
  | Some x ->
      k x

let map f = function
  | None ->
      None
  | Some x ->
      Some (f x)

