(**************************************************************************)
(*                                                                        *)
(*  FORK                                                                  *)
(*                                                                        *)
(*  Author:  Franois Pottier, INRIA Paris-Rocquencourt                   *)
(*  Version: 20101109                                                     *)
(*                                                                        *)
(*  The copyright to this code is held by Institut National de Recherche  *)
(*  en Informatique et en Automatique (INRIA). All rights reserved. This  *)
(*  file is distributed under the license CeCILL-C (see file LICENSE).    *)
(*                                                                        *)
(**************************************************************************)

(* This hack allows the parser to recursively invoke itself when an [include]
   directive is found. *)

(* A more elegant approach would be to make the parser a functor and to apply
   to itself via a recursive module construction; but this is cumbersome,
   because the [token] type must then be generated separately, outside of
   the functor. *)

val load_and_parse: (string -> Syntax.declarations) ref

